#!/usr/bin/php
<?php
$short = "df";
$opts = getopt($short);
$force=false;
$daemon=false;
foreach ($opts as $key => $value) {
	if ($key=='d') $daemon=true;
	if ($key=='f') $force=true;
}
if (!$daemon and !$force) {
	print "opdiscovery.php\n";
	print "-f force run now\n";
	print "-d daemon mode\n";
	exit(0);
}

include("/usr/local/opmon/etc/config.php");

$pid=getmypid();
if ($force) {
	# Generate nedi conf file and run the discovery
	$enabled=NediIntegration::run();
	if ($enabled===false) {
		exit(0);
	}
	op_nedi_discovery();
}
else {
	$pid=getmypid();
	$cmd="/bin/echo '$pid' > /var/run/opdiscovery.pid 2>&1";
	$output = shell_exec($cmd);
	while (true) {
		# Generate nedi conf file and run the discovery
		$enabled=NediIntegration::run();
		if ($enabled===false) {
			sleep(300);
		}
		else {
			op_nedi_discovery();
			log_msg("Finished SNMP Autodiscovery");
			sleep(600);
		}
	}
}
log_msg("Finished SNMP Autodiscovery");
exit(0);
	
function op_nedi_discovery() {
	log_msg("Importing devices and nodes to host discovery");
	$devices=NediIntegration::get_devices();
	$nodes=NediIntegration::get_nodes();
	
	foreach ($devices as $dev) {
		$ip=array();
		$ip[]=$dev->address;
		$tmp=HostDiscovery::get_from_db_by_ips($ip);
		if ($tmp===false) {
			log_msg("Scan Device ".$dev->address);
			$discovery=new HostDiscovery();
			$discovery->set_host_ip($dev->address);
			TaskRunner::runBackground("scanHost",serialize($discovery));
			unset($discovery);
		}
	}
	
	foreach ($nodes as $dev) {
		$ip=array();
		$ip[]=$dev->address;
		$tmp=HostDiscovery::get_from_db_by_ips($ip);
		if ($tmp===false) {
			log_msg("Scan Node ".$dev->address);
			$discovery=new HostDiscovery();
			$discovery->set_host_ip($dev->address);
			TaskRunner::runBackground("scanHost",serialize($discovery));
			unset($discovery);
		}
	}
}

function log_msg($msg) {
	$now=date('[Y-m-d H:i:s]');
	$cmd="/bin/echo '$now $msg' >> /var/log/op-nedi-run.log 2>&1";
	$output = shell_exec($cmd);
}

?>
