#!/usr/bin/php
<?php

include "/usr/local/opmon/etc/config.php";
set_logged_user("opmonadmin");
$mod = "EXTERNAL";

$host_ids = array();
$service_ids = array();

function usage()
{
	print "Usage:\n";
	print "\treimport-state-changes.php -f <opmon log file>\n";
	exit;
}

function st_as_int($st)
{
	$stasint = OK;
	if ($st == "WARNING")
		$stasint = WARNING;
	else if ($st == "CRITICAL")
		$stasint = CRITICAL;
	else if ($st == "UNKNOWN")
		$stasint = UNKNOWN;

	return $stasint;
}

function insert_state($st)
{
	global $host_ids;
	global $service_ids;


	if (count($st) != 8)
		return;

	$hostname = $st[2];
	if (!isset($host_ids[$hostname]))
		$host_ids[$hostname] = get_host_id_by_name($hostname);

	if ($host_ids[$hostname] === false)
		return;

	$sidx = sprintf(
		"%s-%i",
		$hostname,
		$host_ids[$hostname]
	);
	$servicedescription = $st[3];
	if (!isset($service_ids[$sidx]))
		$service_ids[$sidx] = get_service_id($hostname, $servicedescription);
	
	if ($service_ids[$sidx] === false)
		return;

	$q = "INSERT INTO service_state_change_%d ".
	     "VALUES (from_unixtime(%d), %d, %d, %d, %d, '%s')";

	$q = sprintf(
		$q,
		$host_ids[$hostname],
		mysql_real_escape_string($st[1]),
		mysql_real_escape_string($service_ids[$sidx]),
		st_as_int($st[4]),
		($st[5] == "SOFT") ? 0 : 1,
		mysql_real_escape_string($st[6]),
		mysql_real_escape_string($st[7])
	);

	return $q;
}

function main()
{
	global $txtfields;

	$opt = getopt("f:");
	if (!isset($opt['f']))
		usage();


	$lines = @file($opt['f']);
	if ($lines === false) {
		print "Unable to read {$opt['f']} for reading\n";
		usage();
	}

	foreach($lines as $line) {
		if (
		    !strstr($line, "SERVICE ALERT")
		    &&
		    !strstr($line, "CURRENT SERVICE STATE")
		)
			continue;

		if (
		    !preg_match("/\[(\d+)\] SERVICE ALERT: ([^;]+);([^;]+);([^;]+);([^;]+);([^;]+);(.+)$/", $line, $matches)
		    &&
		    !preg_match("/\[(\d+)\] CURRENT SERVICE STATE: ([^;]+);([^;]+);([^;]+);([^;]+);([^;]+);(.+)$/", $line, $matches)
		)
			continue;

		$q = insert_state($matches);
		if (!is_null($q))
			print "$q;\n";
	}

}

main();
